GameplaySettings{
		usepuzzlegrid = false,
		puzzlerows = 8,
		puzzlecols = 4,
        greypercent=0,
        colorcount=6,
        usetraffic = false,
		matchcollectionseconds=1.0,
        automatic_traffic_collisions = false, -- the game shouldn't check for block collisions since we'll be doing that ourselves in this script
        jumpmode="none",
		greyaction="normal",
		multilane=4,

		--track generation settings
		highwaysmooth = 0,
		gravity=-.45,
        playerminspeed = 0.1,--so the player is always moving somewhat
        playermaxspeed = 2.9,--2.5
        minimumbestjumptime = 2.5,--massage the track until a jump of at least this duration is possible
        uphilltiltscaler = 0.8,--set to 1 for normal track. higher for steeper
        downhilltiltscaler = 1.55,--set to 1 for normal track. higher for steeper
        uphilltiltsmoother = 0.03,
        downhilltiltsmoother = 0.06,
        useadvancedsteepalgorithm = false,--set false for a less extreme track
        alldownhill = false
		--end track generation settings
}

SetSkinProperties{
	lanedividers={-3,0,3},
	shoulderlines={-6,6},
	trackwidth = 8
}

function deepcopy(orig) -- a pretty standard lua function for making a copy of a table
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

player={
	score=0,
	prevInput={},
	iPrevRing=0,
	hasFinishedScoringPrevRing=false,
	uniqueName = "Player",
	num=1,
	prevFirstBlockCollisionTested = 1,
	pos = {0,0,0},
	posCosmetic = {0,0,1.5},
	controller = "mouse",
	points = 0 -- used for accumulating points this player earns at each match collection. temp var
}

largestmatch = 0

track = track or {}

function OnTrackCreated(theTrack)--track is created before the traffic
	track = theTrack --store a global copy of the track to maybe use later
	--for i=1,#track do
	--	track[i].hasAstroid = false
	--end

	SetGlobalScore{score=0,showdelta=true}
	
	-- when you return a track table from this function the game will read and apply any changes you made
end

lanespace = 3
half_lanespace = 1.5

timelimit = 0.2

blocks = blocks or {}
blockNodes = blockNodes or {}
blockOffsets = blockOffsets or {}
blockColors = blockColors or {}
nodes = nodes or {}
nodesdisabled = nodesdisabled or {}

function OnTrafficCreated(theTraffic)
	half_lanespace = lanespace / 2

	traffic = theTraffic

    for i = 1, #traffic do
    	local lane = traffic[i].lane

    	local strafe = lane*lanespace
    	--local lane = traffic[i].lane
    	local offset = {strafe,0,0}
--    	for j=traffic[i].chainstart, traffic[i].chainend do
		local block = {}
		block.lane = lane
		block.hidden = false
		--block.tested = false
		block.tested = false
		block.type = traffic[i].type
		blocks[#blocks+1]=block
		--astroidLanes[#astroidLanes+1] = lane
		blockNodes[#blockNodes+1] = traffic[i].impactnode
		blockOffsets[#blockOffsets+1] = offset
		blockColors[#blockColors+1] = track[traffic[i].impactnode].color
		
		--nodes[math.floor((traffic[i].chainstart + traffic[i].chainend) / 2)] = 'u'
		--nodes[traffic[i].chainstart] = 'u'
		if traffic[i].type == 1 then
			if traffic[i].lane == -1 then
				nodes[traffic[i].impactnode] = 'lu'
			else
				if traffic[i].lane == 0 then
					nodes[traffic[i].impactnode] = 'du'
				else
					nodes[traffic[i].impactnode] = 'ur'
				end
			end
		end
		if traffic[i].type == 3 then
			if traffic[i].lane == -1 then
				nodes[traffic[i].impactnode] = 'ld'
			else
				if traffic[i].lane == 0 then
					nodes[traffic[i].impactnode] = 'lr'
				else
					nodes[traffic[i].impactnode] = 'dr'
				end
			end
		end
		if traffic[i].type == 0 then
			nodes[traffic[i].impactnode] = 'u'
		end
		if traffic[i].type == 2 then
			nodes[traffic[i].impactnode] = 'd'
		end
		if traffic[i].type == 4 then
			nodes[traffic[i].impactnode] = 'l'
		end
		if traffic[i].type == 5 then
			nodes[traffic[i].impactnode] = 'r'
		end
		
		nodesdisabled[traffic[i].impactnode] = false
--    	end
    end

    --return traffic -- when you return a traffic table from this function the game will read and apply any changes you made
end

beakerPos = {0,0,1.5}
beakerScale = {.7,.7,.7}
function OnSkinLoaded()-- called after OnTrafficCreated. The skin script has loaded content.
	--CreateClone{name="beaker", prefabName="Vehicle", attachToTrackWithNodeOffset=-1, transform={pos=beakerPos,scale=beakerScale}}
	local arrownodesleft = {}
	local arrownodesdown = {}
	local arrownodesup = {}
	local arrownodesright = {}
	for i=1, #track do
		if nodes[i] == 'lu' then
			arrownodesleft[#arrownodesleft+1] = i
			arrownodesup[#arrownodesup+1] = i
		end
		if nodes[i] == 'du' then
			arrownodesdown[#arrownodesdown+1] = i
			arrownodesup[#arrownodesup+1] = i
		end
		if nodes[i] == 'ur' then
			arrownodesup[#arrownodesup+1] = i
			arrownodesright[#arrownodesright+1] = i
		end
		if nodes[i] == 'ld' then
			arrownodesleft[#arrownodesleft+1] = i
			arrownodesdown[#arrownodesdown+1] = i
		end
		if nodes[i] == 'lr' then
			arrownodesleft[#arrownodesleft+1] = i
			arrownodesright[#arrownodesright+1] = i
		end
		if nodes[i] == 'dr' then
			arrownodesdown[#arrownodesdown+1] = i
			arrownodesright[#arrownodesright+1] = i
		end
		if nodes[i] == 'l' then
			arrownodesleft[#arrownodesleft+1] = i
		end
		if nodes[i] == 'd' then
			arrownodesdown[#arrownodesdown+1] = i
		end
		if nodes[i] == 'u' then
			arrownodesup[#arrownodesup+1] = i
		end
		if nodes[i] == 'r' then
			arrownodesright[#arrownodesright+1] = i
		end
	end
	
	local arrowoffsetsleft = {}
	local arrowoffsetsdown = {}
	local arrowoffsetsup = {}
	local arrowoffsetsright = {}
	
	for i=1,#arrownodesleft do
		arrowoffsetsleft[i] = {-4.5,0,0}
	end
	for i=1,#arrownodesdown do
		arrowoffsetsdown[i] = {-1.5,0,0}
	end
	for i=1,#arrownodesup do
		arrowoffsetsup[i] = {1.5,0,0}
	end
	for i=1,#arrownodesright do
		arrowoffsetsright[i] = {4.5,0,0}
	end
	
	--BatchRenderEveryFrame{prefabName="Arrow",
	--						locations=arrownodes,
	--						offsets=nil}
	
	BatchRenderEveryFrame{prefabName="ArrowLeft",
							locations=arrownodesleft,
							offsets=arrowoffsetsleft}
	BatchRenderEveryFrame{prefabName="ArrowDown",
							locations=arrownodesdown,
							offsets=arrowoffsetsdown}
	BatchRenderEveryFrame{prefabName="ArrowUp",
							locations=arrownodesup,
							offsets=arrowoffsetsup}
	BatchRenderEveryFrame{prefabName="ArrowRight",
							locations=arrownodesright,
							offsets=arrowoffsetsright}
	
	--CreateClone{name="blockup", prefabName="Arrow", attachToTrackWithNodeOffset=-1}
	--SendCommand{command="SetTransform", name="blockup", param={pos={0,1.7,1.1},scale={1,1,1}}}
	
	CreateClone{name="whitearrowleft", prefabName="WhiteArrowLeft", attachToTrackWithNodeOffset=-1}
	SendCommand{command="SetTransform", name="whitearrowleft", param={pos={-4.5,0,3.5},scale={1,1,1}}}
	CreateClone{name="whitearrowdown", prefabName="WhiteArrowDown", attachToTrackWithNodeOffset=-1}
	SendCommand{command="SetTransform", name="whitearrowdown", param={pos={-1.5,0,3.5},scale={1,1,1}}}
	CreateClone{name="whitearrowup", prefabName="WhiteArrowUp", attachToTrackWithNodeOffset=-1}
	SendCommand{command="SetTransform", name="whitearrowup", param={pos={1.5,0,3.5},scale={1,1,1}}}
	CreateClone{name="whitearrowright", prefabName="WhiteArrowRight", attachToTrackWithNodeOffset=-1}
	SendCommand{command="SetTransform", name="whitearrowright", param={pos={4.5,0,3.5},scale={1,1,1}}}
	
	SetGlobalScore{score=0,showdelta=false}
	SetScoreboardNote{text="Sequence Bonus: 0%"}
	
end

score = 0 --the global score shared by all players co-operatively

iCurrentRing = 0 --Update function keeps this current
--prevFirstBlock = 1
blocksToHide = {}
storedtype = -1
storedblocks = {0,0,0}
colheights = {0,0,0}
overflowtime = 10.0
overflowcol = 1
lastinput = ""
twokeyblock = false
seqbonus = 0
lastcheckedmissed = 0

function round(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end

function Update(dt, tracklocation, playerstrafe, input) --called every frame
	--iCurrentRing = math.floor(GetCurrentTrackLocation())
	--local input = GetInput()
	
	iCurrentRing = math.floor(tracklocation)
	
	Disposable:Update(dt)
	Schedule:Update(dt)
	
	local playersInput = input["players"]
	local mouseInput = input["mouse"]
	local keys = input["keyboard"]
	
	local currentinput = ""
	if keys["leftarrow"] or keys["d"] then
		currentinput = currentinput .. "l"
	end
	if keys["downarrow"] or keys["f"] then
		currentinput = currentinput .. "d"
	end
	if keys["uparrow"] or keys["j"] then
		currentinput = currentinput .. "u"
	end
	if keys["rightarrow"] or keys["k"] then
		currentinput = currentinput .. "r"
	end
	
	if twokeyblock == true and currentinput == "" then
		twokeyblock = false
	end
	
	local firstframe
	local lastframe
	
	if iCurrentRing == 1 then
		firstframe = iCurrentRing
	else
		firstframe = iCurrentRing - 1
		while firstframe > 1 and track[iCurrentRing].seconds - track[firstframe].seconds < timelimit do
			firstframe = firstframe - 1
		end
	end
	
	if iCurrentRing == #track then
		lastframe = iCurrentRing
	else
		lastframe = iCurrentRing + 1
		while lastframe < #track and track[lastframe].seconds - track[iCurrentRing].seconds < timelimit do
			lastframe = lastframe + 1
		end
	end
	
	if currentinput ~= lastinput and currentinput ~= "" and twokeyblock == false then
		local result
		local maybepartial = false
		--result = checkhit(currentinput, 0, 1)
		--if result == 0 then
		--	maybepartial = true
		--end
		--if result ~= 1 then
		--	result = checkhit(currentinput, -1, 0.8)
		--	if result == 0 then
		--		maybepartial = true
		--	end
		--	if result ~= 1 then
		--		result = checkhit(currentinput, 1, 0.8)
		--		if result == 0 then
		--			maybepartial = true
		--		end
		--	end
		--end
		
		for i=firstframe,lastframe do
			local multi = math.abs(track[i].seconds - track[iCurrentRing].seconds) / timelimit
			multi = (multi * 0.2) + 0.8
			multi = round(multi, 2)
			if multi > 1 then multi = 1 end
			if multi < 0.8 then multi = 0.8 end
			result = checkhit(currentinput, i-iCurrentRing, multi)
			if result == 0 then
				maybepartial = true
			end
			if result == 1 then break end
		end
		
		
		if result ~= 1 and maybepartial == false then
			score = score - 20
			SetGlobalScore{score=score,showdelta=true}
			if string.len(currentinput) > 1 then
				twokeyblock = true
			end
			seqbonus = 0
			SetScoreboardNote{text="Sequence Bonus: 0%"}
		end
	end
	
	--if firstframe > 1 and nodesdisabled[firstframe - 1] == false then
	if firstframe > 1 and firstframe - lastcheckedmissed > 1 then
		for i=lastcheckedmissed+1,firstframe-1 do
			if nodesdisabled[i] == false then
				seqbonus = 0
				SetScoreboardNote{text="Sequence Bonus: 0%"}
				nodesdisabled[i] = true
			end
		end
		lastcheckedmissed = firstframe-1
	end
	
	lastinput = currentinput
	
end

function checkhit(input, offset, multi)
	if nodesdisabled[iCurrentRing+offset] == true or nodesdisabled[iCurrentRing+offset] == nil then
		return -1
	end
	if nodes[iCurrentRing+offset] == input then
		score = score + (100 * multi * string.len(input) * ((seqbonus / 100)+1))
		SetGlobalScore{score=score,showdelta=true}
		nodesdisabled[iCurrentRing+offset] = true
		PlaySound{name="hit",pitch=pitch,volume=0.5,loopseconds=0}
		seqbonus = seqbonus + 5
		SetScoreboardNote{text="Sequence Bonus: " .. seqbonus .. "%"}
		if string.len(input) > 1 then
			twokeyblock = true
		end
		for i = 1, #input do
			lightarrow(input:sub(i, i))
		end
		return 1
	end
	if string.find(nodes[iCurrentRing+offset], input) ~= nil then
		return 0
	end
	return -1
end

function lightarrow(a)
	local pfab
	local x
	if a == "l" then
		pfab = "ArrowLeftAlpha"
		x = -4.5
	elseif a == "d" then
		pfab = "ArrowDownAlpha"
		x = -1.5
	elseif a == "u" then
		pfab = "ArrowUpAlpha"
		x = 1.5
	else
		pfab = "ArrowRightAlpha"
		x = 4.5
	end
	
	for i = 1, 10 do
		--Schedule:Add(AddDisposableProxy,
		--				{prefab = pfab,
		--				pos = {x, 0, 3.5},
		--				destroyAfter = 0.5 - (i * 0.05)},
		--				i * 0.025)
		Disposable:Add{prefab = pfab,
						pos = {x, 0, 3.5},
						posChange = {0, 1, 0},
						scaleChange = {1, 1, 1},
						destroyAfter = 0.75 - (i * 0.05)}
	end
end

function OnRequestFinalScoring()
	return {
		rawscore = score,
		bonuses = {},
		finalscore = (score)
	}
end

Disposable = {objects = {}, nextId = 1}
Disposable.__index = Disposable
function Disposable:Add(opt)
	
	local newObject = {id = self.nextId,								-- short id for comparison
						unique = "Disposable" .. self.nextId,			-- unique name for CreateClone
						prefab = opt.prefab or "Need to set prefab",	-- prefab for object
						trackSection = opt.trackSection or -1,			-- where to attach to track, or -1 for not
						pos = opt.pos or {0, 0, 0},						-- position
						scale = opt.scale or {1, 1, 1},					-- scale
						posChange = opt.posChange or nil,				-- position change per second
						scaleChange = opt.scaleChange or nil,			-- scale change per second
						destroyAfter = opt.destroyAfter or nil,			-- how long left until object is destroyed. decreases
						updateFunction = opt.updateFunction or nil,		-- user function for updating object can be specified
						userData = opt.userData or nil}					-- place for storing persistant data for updateFunction if it is used
	
	table.insert(self.objects, newObject)
	
	self.nextId = self.nextId + 1
	
	CreateClone{name=newObject.unique, prefabName=newObject.prefab, attachToTrackWithNodeOffset=newObject.trackSection}
	SendCommand{command="SetTransform", name=newObject.unique, param={pos=newObject.pos,scale=newObject.scale}}
end

function Disposable:Update(dt)
	local toDestroy = {}
	for i = 1, #self.objects do
		local needToUpdate = false -- only settransform if things change
		if self.objects[i].updateFunction ~= nil then -- call user function
			self.objects[i].updateFunction(self.objects[i], dt)
			needToUpdate = true
		end
		if self.objects[i].posChange ~= nil then -- apply position change
			self.objects[i].pos = {(self.objects[i].posChange[1] * dt) + self.objects[i].pos[1],
									(self.objects[i].posChange[2] * dt) + self.objects[i].pos[2],
									(self.objects[i].posChange[3] * dt) + self.objects[i].pos[3]}
			needToUpdate = true
		end
		if self.objects[i].scaleChange ~= nil then -- apply scale change
			self.objects[i].scale = {(self.objects[i].scaleChange[1] * dt) + self.objects[i].scale[1],
									(self.objects[i].scaleChange[2] * dt) + self.objects[i].scale[2],
									(self.objects[i].scaleChange[3] * dt) + self.objects[i].scale[3]}
			needToUpdate = true
		end
		if self.objects[i].destroyAfter ~= nil then -- decrease time until destroy
			self.objects[i].destroyAfter = self.objects[i].destroyAfter - dt
			if self.objects[i].destroyAfter <= 0 then -- if time to destroy, do not update, and add to destroy list
				needToUpdate = false
				table.insert(toDestroy, self.objects[i].id)
			end
		end
		if needToUpdate then -- update transform
			SendCommand{command="SetTransform", name=self.objects[i].unique, param={pos=self.objects[i].pos,scale=self.objects[i].scale}}
		end
	end
	
	for i = 1, #toDestroy do -- loop through destroy list removing objects
		for j = 1, #self.objects do
			if self.objects[j].id == toDestroy[i] then
				SendCommand{command="Hide", name=self.objects[j].unique}
				table.remove(self.objects, j)
				break
			end
		end
	end
end

Schedule = {items = {}, nextId = 1}
Schedule.__indes = Schedule
function Schedule:Add(f, p, dt) -- function, parameter, delta time
	local newItem = {id = self.nextId,
						func = f,
						param = p,
						timeLeft = dt}
	
	table.insert(self.items, newItem)
	
	self.nextId = self.nextId + 1
end

function Schedule:Update(dt)
	local toDestroy = {}
	for i = 1, #self.items do
		self.items[i].timeLeft = self.items[i].timeLeft - dt
		if self.items[i].timeLeft <= 0 then
			table.insert(toDestroy, self.items[i].id)
			self.items[i].func(self.items[i].param)
		end
	end
	for i = 1, #toDestroy do -- loop through destroy list removing items
		for j = 1, #self.items do
			if self.items[j].id == toDestroy[i] then
				table.remove(self.items, j)
				break
			end
		end
	end
end

function AddDisposableProxy(opt)
	Disposable:Add(opt)
end
