jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

skinvars = GetSkinProperties()
--trackWidth = skinvars["trackwidth"]
trackWidth = 11.5 -- uses a wide water track even for vehicles
fullsteep = jumping or skinvars.prefersteep

SetScene{
	glowpasses = ifhifi(4,0),
	glowspread = ifhifi(0.5,0),
	radialblur_strength = 0,
--	radialblur_strength = fif(jumping,2,0),
	--environment = "city",
	watertint = {r=255,g=255,b=255,a=234},
	watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",--texture used to color the dynamic "digital water" surface
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = ifhifi(500,100),
	airdebris_density = ifhifi(10,2),
	usedefaultrails=false,
	useblackgrid=false,
	twistmode={curvescaler=1, steepscaler=fif(fullsteep, 1, .7)} -- note: "cork" is the same as {curvescaler=1, steepscaler=1} and "cork_flatish" is the same as {curvescaler=1, steepscaler=.4}
	--skywirecolor={r=255,g=0,b=0}
}

--LoadSounds{
--	hit="hit.wav",
--	hitgrey="hitgrey.wav",
--	trickfail="hitgrey.wav",
--	matchsmall="matchsmall.wav",
--	matchmedium="matchmedium.wav",
--	matchlarge="matchlarge.wav",
--	matchhuge="matchhuge.wav",
--	overfillwarning="overfillwarning.wav"
--}

if jumping then
	SetPlayer{
		--showsurfer = true,
		--showboard = true,
		cameramode = "first_jumpthird",
		--cameramode_air = "third",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={ --sets the camera position when in first person mode. Can change this while the game is running.
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0
		},
		camthird={ --sets the two camera positions for 3rd person mode. lerps out towards pos2 when the song is less intense
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0,
			pos2={0,2.8,-3.50475},
			rot2={20.49113,0,0},
			strafefactorFar = 0},
		surfer={ --set all the models used to represent the surfer
			arms={
				--mesh="arm.obj",
				shader="RimLightHatchedSurfer",
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},
					_RimColor={0,63,192}
				},
				texture="FullLeftArm_1024_wAO.png"
			},
			--leg={
			--	mesh="foot.obj",
			--	shader="RimLightHatchedSurfer",
			--	shadercolors={
			--		_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=-1, paramMax=2},
			--		_RimColor={0,49,242}
			--		--_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}
			--	},
			--	texture="foot.png"
			--},
			board={
				--mesh="wakeboard.obj",
				shader=ifhifi("RimLightHatchedSurferExternal","VertexColorUnlitTinted"), -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3999,
				shadercolors={ --each color in the shader can be set to a static color, or change every frame like the arm model above
					_Color={colorsource="highway", scaletype="intensity", minscaler=5, maxscaler=5},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=11
				},
				texture="board_internalOutline.png"
			},
			body={
				--mesh="surferbot.obj",
				shader="RimLightHatchedSurferExternal", -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3000,
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=1.7
				},
				texture="robot_HighContrast.png"
			}
		}
	}
else
	SetPlayer{
		--showsurfer = false,
		--showboard = false,
		cameramode = "third",
	--	cameramode_air = "first",--"first_jumptrickthird", --start in first, go to third for jumps and tricks

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0}},
		camthird={
			--pos={0,2,-0.5},
			--rot={30,0,0},
			pos={0,25,9},
			rot={65,0,0},
			strafefactorFar = 0,
			--pos2={0,5,-4},
			--rot2={30,0,0},
			pos2={0,25,9},
			rot2={65,0,0},
			strafefactorFar = 0,
			transitionspeed = 1,
			puzzleoffset=-0.65,
			puzzleoffset2=-1.5},
		vehicle={ --livecoding not supported here
			--min_hover_height= 0.23,
			--max_hover_height = 0.23, -- 0.75
			use_water_rooster = false,
			--roostercolor = {9,9,18,255},
			--water_rooster_z_offset = -.81,
            --smooth_tilting = true,
            --smooth_tilting_speed = 10,
            --smooth_tilting_max_offset = -20,
			--pos={x=0,y=0,z=0},
			--mesh="vehicle1a.obj",
			--shader="VertexColorUnlitTinted",
			--shadercolors={
			--	_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}},
			--texture="vehicle1a_ao.png",
			scale = {x=0,y=0,z=0},
			--thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
			--			perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
			--			extrusions=22,
			--			stretch=-0.1191,
			--			updateseconds = 0.025,
			--			instances={
			--				{pos={0,.281,-1.33},rot={0,0,0},scale={1,1,1}},
			--				{pos={.1236,0.2,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
			--				{pos={-.1236,0.2,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
			--			}}
		}
	}
	--[[
	SetPlayer{
		cameramode = "third",

		camfirst={
			pos={0,1.84,-0.8},
			rot={20,0,0},
			strafefactor=1},
		camthird={
			pos={0.66,2,-0.5},
			rot={30,0,0},
			strafefactor=0.66,
			pos2={1,5,-4},
			rot2={30,0,0},
			strafefactorFar=.75,
			transitionspeed = 1,
			puzzleoffset=-0.85,
			puzzleoffset2=-1.75},
		vehicle={ --livecoding not supported here
			pos={x=0,y=0,z=0},
			mesh="vehicle1a.obj",
			shader="VertexColorUnlitTinted",
			shadercolors={
				_Color={r=1,g=1,b=1}},
				--_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}},
			texture="vehicle1a_ao.png",
			scale = {x=1,y=1,z=1},
			thrusters = {crossSectionShape={{-.5,.5,0},{.5,.5,0},{.5,-.5,0},{-.5,-.5,0}},
						perShapeNodeColorScalers={1,1,0,0},
						extrusions=22,
						stretch=-0.1191,
						instances={
							{pos={0,.281,-1.33},rot={0,0,0},scale={1,1,1}},
							{pos={.1236,0.2,-1.297},rot={0,0,58.713},scale={.7,.7,.7}},
							{pos={-.1236,0.2,-1.297},rot={0,0,313.7366},scale={.7,.7,.7}}
						}}
			}
	}
	--]]
end

if hifi then
	SetSkybox{
		sky={
			month=2,
			hour=1,
			minute=36,
			longitude=185.6,--175,
			cloudmaxheight=1.2,
			cloudminheight=-1.2,
			clouddensity=0.5,
			cirrusposition=0,
			useProceduralAmbientLight = true,
			useProceduralSunLight = true
		}
	}
else
	SetSkybox{ --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
		custom={
			_FrontTex = "Front.png",
			_BackTex = "Back.png",
			_RightTex = "Right.png",
			_LeftTex = "Left.png",
			_UpTex = "Up.png",
			_DownTex = "Down.png"
		}
	}
end

SetTrackColors{ --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
    {r=93, g=8, b=132},
    {r=0.125, g=0.46, b=0.77},
    {r=0.047, g=0.5098, b=0.94},
    {r=1.0, g=0.85, b=0.4157},
	{r=1.0, g=0.27, b=0.2},
    {r=1,g=0,b=0}
}

SetBlockColors{ --this is only used for puzzle modes (which you don't have yet) with multiple colors of blocks
    {r=93, g=8, b=132},
	{r=1.0, g=0.27, b=0.2},
    {r=0.047, g=0.5098, b=0.94},
    {r=1.0, g=0.85, b=0.4157},
	{r=0, g=0.29, b=0.08},
    {r=1,g=0,b=0}
}

--if hifi then
--	CreateLight{
--		railoffset = -3,
--		range = 10,
--		intensity = 2,
--		transform = {
--			position={0,.5,0}
--		},
--		color="highway"
--	}
--end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="aRing_FadedEarringAlphaTestable_1024.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=22,
	percentringed=.2,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16
}

if jumping then wakeHeight=(ifhifi(4,2)) else wakeHeight = 0 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = 0
	--fallrate = 0.95,
	--shader = "VertexColorUnlitTintedAddSmooth",
	--layer = 13, -- looks better not rendered in background when water surface is not type 2
	--bottomcolor = {r=114,g=148,b=255},
	--topcolor = {r=0,g=0,b=0}
}

CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		transform={pos={0,0,126},scale={scaletype="intensity",min={55,99,900},max={66,120,900}}},
		mesh="danishCookie_boxes.obj",
		shader="RimLightHatched",
		shadercolors={
			_Color={0,0,0},
			_RimColor={1,1,1}
		}
	}
}

--This shows that scripted dynamic meshes can be used, but you probably don't need this
--function AddQuadIndices(t, index0, index1, index2, index3)
--	table.insert(t, index0)
--	table.insert(t, index1)
--	table.insert(t, index2)
--	table.insert(t, index1)
--	table.insert(t, index3)
--	table.insert(t, index2)
--end
--
--if mesh1==nil then --if this mesh hasn't been created yet
--	verts = {}
--	verts[1] = {x=-0.5, y=0.5, z=0.5}
--	verts[2] = {x=0.5, y=0.5, z=0.5}
--	verts[3] = {x=-0.5, y=0.5, z=-0.5}
--	verts[4] = {x=0.5, y=0.5, z=-0.5}
--	verts[5] = {x=-0.5, y=-0.5, z=0.5}
--	verts[6] = {x=0.5, y=-0.5, z=0.5}
--	verts[7] = {x=-0.5, y=-0.5, z=-0.5}
--	verts[8] = {x=0.5, y=-0.5, z=-0.5}
--	uvs = {}
--	uvs[1] = {0,1}
--	uvs[2] = {1,1}
--	uvs[3] = {0,1}
--	uvs[4] = {1,1}
--	uvs[5] = {0,0}
--	uvs[6] = {1,0}
--	uvs[7] = {0,0}
--	uvs[8] = {1,0}
--	indices = {}
--	AddQuadIndices(indices, 0, 1, 2, 3)
--	AddQuadIndices(indices, 1, 0, 5, 4)
--	AddQuadIndices(indices, 3, 1, 7, 5)
--	AddQuadIndices(indices, 2, 3, 6, 7)
--	AddQuadIndices(indices, 0, 2, 4, 6)
--	AddQuadIndices(indices, 5, 4, 7, 6)
--
--	mesh1 = BuildMesh{
--		vertextable=verts,
--		indextable=indices,
--		uvtable = uvs,
--		calculatenormals = true
--	}
--end
--
--function Update(dt) --called every frame if it exists
--	for i=1,4 do
--		verts[i].y = dt*100
--	end
--
--	BuildMesh{
--		mesh=mesh1,
--		vertextable = verts,
--		calculatenormals = true
--	}
--end

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		--mesh="skyscraper42.obj",
		mesh="skyscraper_withbase.obj",
		--shader="VertexColorUnlitTintedAlpha",
		shader="PsychoBuilding2",
		diffuseinair = true,
		shadercolors={
			--_Color={r=255,g=255,b=255}
			--_Color="highwaysmooth"
			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
		},
		texture="White.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}

--CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
--	name="BuildingCloneMeToo",
--	gameobject={
--		pos={x=0,y=0,z=0},
--		--mesh="skyscraper42.obj",
--		mesh="skyscraper42_withbase.obj",
--		--shader="VertexColorUnlitTintedAlpha",
--		shader="PsychoBuilding",
--		shadercolors={
--			--_Color={r=255,g=255,b=255}
--			--_Color="highwaysmooth"
--			--_Color = {colorsource="highway", scaletype="intensity", minscaler=6, maxscaler=6}
--			_Color = {colorsource="highway", scaletype="intensity", minscaler=2, maxscaler=2}
--		},
--		--texture="cliffRails.png",
--		--texture="skyscraper.png",
--		scale = {x=1,y=1,z=1}
--	}
--}

track = GetTrack()--get the track data from the game engine

if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if i%80==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

--		if (i+40)%120==0 then
--			buildingNodesToo[#buildingNodesToo+1] = i
--			local xOffset = 150 + 1650*math.random()
--			if math.random() > 0.5 then xOffset = xOffset * -1 end
--			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
--		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=50,
                    		maxDistanceShown=2000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}

--	BatchRenderEveryFrame{prefabName="BuildingCloneMeToo", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
--							locations=buildingNodesToo,
--                    		rotateWithTrack=false,
--                    		maxShown=50,
--                    		maxDistanceShown=2000,
--							offsets=offsetsToo,
--							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
--							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
--						}
end

--[[
CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="SpriteTest",
	active=false,
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="skyscraper42_withbase.obj",--mesh doesn't matter, the spritebatch won't use it
		shader="VertexColorUnlitTintedAddSmooth",
		shadercolors={
			_Color = {255,255,255}
		},
		texture="Frequency_OnBlack.jpg"
	}
}

spritenodes = {}
spriteoffsets = {}
for i=1,#track do
	if i%80==0 then
		spritenodes[#spritenodes+1]=i
		local xOffset = 150 + 300*math.random()
		if math.random() > 0.5 then xOffset = xOffset * -1 end
		spriteoffsets[#spriteoffsets+1] = {xOffset,-100,0}
	end
end

CreateSpriteBatch{
	prefabName="SpriteTest",--the material from this prefab is used
	locations=spritenodes,
	offsets={120,0,0},
	scales={30,30,30},
	repeaterSpacings={2,4,6,8,10,12,14,16,18,20}
}

--]]

CreateObject{--skywires, the red lines in the sky. A railed object is attached to the track and moves along it with the player.
	railoffset=0,
	floatonwaterwaves = false,
	gameobject={
		name="scriptSkyWires",
		pos={x=0,y=0,z=0},
		mesh="skywires.obj",
		renderqueue=1000,
		layer=ifhifi(18,13), -- in low detail the glow camera (layer 18) is disabled, so move the skywires to the main camera's layer (13)
		shader="VertexColorUnlitTintedSkywire",
		shadercolors={
			_Color="highway" --{r=255,g=0,b=0}
		},
		texture="White.png",
		scale = {x=1,y=1,z=1},
		lookat = "end"
	}
}

CreateObject{
	name="Arrow",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrow.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=200,g=200,b=200}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}

CreateObject{
	name="ArrowLeft",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowleft.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=255,g=69,b=51}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="ArrowDown",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowdown.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=255,g=217,b=106}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="ArrowUp",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowup.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=12,g=130,b=240}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="ArrowRight",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowright.obj",
		shader="IlluminDiffuse",
		shadercolors={
			--_Color={r=93,g=8,b=132}
			_Color={r=140,g=12,b=198}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}

CreateObject{
	name="WhiteArrowLeft",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowleft.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=200,g=200,b=200}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="WhiteArrowDown",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowdown.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=200,g=200,b=200}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="WhiteArrowUp",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowup.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=200,g=200,b=200}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}
CreateObject{
	name="WhiteArrowRight",
	gameobject={
		pos={x=0,y=0,z=1},
		mesh="arrowright.obj",
		shader="IlluminDiffuse",
		shadercolors={
			_Color={r=200,g=200,b=200}
			--_Color="highwaysmooth"
		},
		texture="White.png",
		scale = {x=2,y=2,z=2}
	}
}

CreateObject{
	name="ArrowLeftAlpha",
	gameobject={
		pos={x=0,y=0,z=1.1},
		mesh="arrowleft.obj",
		shader="VertexColorUnlitTintedAlpha2",
		shadercolors={
			_Color={r=255,g=69,b=51}
			--_Color="highwaysmooth"
		},
		texture="White_alpha20.png",
		scale = {x=2.2,y=2.2,z=2.2}
	}
}
CreateObject{
	name="ArrowDownAlpha",
	gameobject={
		pos={x=0,y=0,z=1.1},
		mesh="arrowdown.obj",
		shader="VertexColorUnlitTintedAlpha2",
		shadercolors={
			_Color={r=255,g=217,b=106}
			--_Color="highwaysmooth"
		},
		texture="White_alpha20.png",
		scale = {x=2.2,y=2.2,z=2.2}
	}
}
CreateObject{
	name="ArrowUpAlpha",
	gameobject={
		pos={x=0,y=0,z=1.1},
		mesh="arrowup.obj",
		shader="VertexColorUnlitTintedAlpha2",
		shadercolors={
			_Color={r=12,g=130,b=240}
			--_Color="highwaysmooth"
		},
		texture="White_alpha20.png",
		scale = {x=2.2,y=2.2,z=2.2}
	}
}
CreateObject{
	name="ArrowRightAlpha",
	gameobject={
		pos={x=0,y=0,z=1.1},
		mesh="arrowright.obj",
		shader="VertexColorUnlitTintedAlpha2",
		shadercolors={
			_Color={r=140,g=12,b=198}
			--_Color="highwaysmooth"
		},
		texture="White_alpha20.png",
		scale = {x=2.2,y=2.2,z=2.2}
	}
}

if jumping then
	--[[
	CreateObject{--left rope puller
		railoffset=18,
		floatonwaterwaves = true,
		tiltsmoother = 44,
		gameobject={
			pos={
				x=-7.5,
				y=.25,
				z=1},
			mesh="staggersphere.obj",
			shader="rimlight.shader",--shader text files can be used. Take the compiled shader from unity and give it a "shader" file extension to use it
			shadercolors={
				_Color={r=46,g=46,b=46},
				_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}
			},
			texture="White.png",
			scale = {x=1.25,y=1.25,z=1.25}
		}
	}

	CreateObject{--right rope puller
		railoffset=18,
		floatonwaterwaves = true,
		tiltsmoother = 44,
		gameobject={
			pos={
				x=7.5,
				y=.25,
				z=1},
			mesh="staggersphere.obj",
			shader="rimlight.shader",
			shadercolors={
				_Color={r=46,g=46,b=46},
				_RimColor={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3}
			},
			texture="White.png",
			scale = {x=1.25,y=1.25,z=1.25}
		}
	}
	--]]
end

--RAILS. rails are the bulk of the graphics in audiosurf. Each one is a 2D shape extruded down the length of the track.

if #skinvars["lanedividers"] > 2 then
	local laneDividers = skinvars["lanedividers"]
	for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.1},
			crossSectionShape={
				{x=-.07,y=0},
				{x=.07,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="static",
			color = {r=255,g=255,b=255},
			flatten=false,
			nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTinted"
		}
	end
end

CreateRail{--big cliff
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=11,y=-2},
		{x=22,y=-11},
		{x=22,y=-40},
		{x=-22,y=-40},
		{x=-22,y=-11},
		{x=-11,y=-2}
		},
	perShapeNodeColorScalers={
		1,
		1,
		.4,
		.4,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	wrapnodeshape = false,
	texture="cliffRails.png",
	fullfuture = true,--ifhifi(true,false),
	stretch = 3,
	calculatenormals = true,
	shader="Cliff"
}

--CreateRail{--big cliff low detail. This one will almost always be able to render the song's full future.
--	positionOffset={
--		x=0,
--		y=0},
--	crossSectionShape={
--		{x=0,y=-4},
--		{x=0,y=-35}
--		},
--	perShapeNodeColorScalers={
--		1,
--		.4},
--	colorMode="highway",
--	color = {r=255,g=255,b=255},
--	flatten=false,
--	wrapnodeshape = true,
--	texture="cliffRails.png",
--	fullfuture = true,
--	stretch = 3,
--	calculatenormals = true,
--	shader="Cliff"
--}

--[[
CreateRail{--distant water
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=-12,y=-5.5},
		{x=12,y=-5.5}},
	perShapeNodeColorScalers={
		1,
		1},
	colorMode="static",
	color = {r=0,g=137,b=255},
	flatten=false,
	wrapnodeshape = false,
    layer=13,
	texture="White.png",
	shader="VertexColorUnlitTinted"
}
--]]

CreateRail{--left rail
	positionOffset={
		x=-trackWidth,
		y=0},
	crossSectionShape={
		{x=-.95,y=1.4},
		{x=0,y=1},
		{x=0,y=-3},
		{x=-.95,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="cliffRails.png",
	shader="CliffRail"
}

CreateRail{--right rail
	positionOffset={
		x=trackWidth,
		y=0},
	crossSectionShape={
		{x=0,y=1},
		{x=.95,y=1.4},
		{x=.95,y=-3},
		{x=0,y=-3}},
	perShapeNodeColorScalers={
		1,
		.5,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="cliffRails.png",
	shader="CliffRail"
}

CreateRail{--left aurora core
	positionOffset={
		x=-18,
		y=33},
	crossSectionShape={
		{x=-13,y=.5},
		{x=-9,y=.5},
		{x=-9,y=-.5},
		{x=-13,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="White.png",
	shader="VertexColorUnlitTinted"
}

CreateRail{--right aurora core
	positionOffset={
		x=18,
		y=33},
	crossSectionShape={
		{x=9,y=.5},
		{x=13,y=.5},
		{x=13,y=-.5},
		{x=9,y=-.5}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="White.png",
	shader="VertexColorUnlitTinted"
}

auroraExtent = ifhifi(77, 22)
CreateRail{--left aurora
	positionOffset={
		x=-18,
		y=33},
	crossSectionShape={
		{x=-auroraExtent,y=.5},
		{x=-11,y=.5},
		{x=-11,y=-.5},
		{x=-auroraExtent,y=-.5}},
	perShapeNodeColorScalers={
		0,
		1,
		1,
		0},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=true,
    layer=13,
	texture="White.png",
	shader="VertexColorUnlitTintedAddSmoothNoCull"
}

CreateRail{--right aurora
	positionOffset={
		x=18,
		y=33},
	crossSectionShape={
		{x=11,y=.5},
		{x=auroraExtent,y=.5},
		{x=auroraExtent,y=-.5},
		{x=11,y=-.5}},
	perShapeNodeColorScalers={
		1,
		0,
		0,
		1},
	colorMode="aurora",
	color = {r=255,g=255,b=255},
	flatten=true,
    layer=13,
	texture="White.png",
	shader="VertexColorUnlitTintedAddSmoothNoCull"
}

if hifi then
	CreateRail{--left shell
		positionOffset={
			x = -trackWidth + .23,
			y=0},
		crossSectionShape={
			{x=-.3,y=3},
			{x=-.1,y=3},
			{x=.1,y=-3},
			{x=-.3,y=-3}},
		perShapeNodeColorScalers={
			.3,
			.2,
			.8,
			.2},
		colorMode="highway",
		flatten=true,
		wrapnodeshape = false,
		shader="proximity_2way_Color",
		renderqueue=3998,
	    layer=13,
		shadercolors={_nearColor={r=255,g=255,b=255,a=0},
						_farColor={r=255,g=255,b=255,a=214}},
		shadersettings={_nearDistance=0, _farDistance=103.5}
	}

	CreateRail{--right shell
		positionOffset={
			x=trackWidth - .23,
			y=0},
		crossSectionShape={
			{x=.3,y=-3},
			{x=-.1,y=-3},
			{x=-.1,y=3},
			{x=.3,y=3}},
		perShapeNodeColorScalers={
			.3,
			.8,
			.2,
			.2},
		colorMode="highway",
		flatten=true,
		wrapnodeshape = false,
		shader="proximity_2way_Color",
		renderqueue=3998,
	    layer=13,
		shadercolors={_nearColor={r=255,g=255,b=255,a=0},
						_farColor={r=255,g=255,b=255,a=214}},
		shadersettings={_nearDistance=0, _farDistance=103.5}
	}
end

CreateRail{--left shell topper
	positionOffset={
		x=-trackWidth + .23,
		y=0},
	crossSectionShape={
		{x=-.1,y=3},
		{x=-.1,y=3.2},
		{x=.1,y=3.2},
		{x=.1,y=3}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="White.png",
	shader="VertexColorUnlitTinted"
}

CreateRail{--right shell top
	positionOffset={
		x=trackWidth - .23,
		y=0},
	crossSectionShape={
		{x=-.1,y=3},
		{x=-.1,y=3.2},
		{x=.1,y=3.2},
		{x=.1,y=3}},
	perShapeNodeColorScalers={
		1,
		1,
		1,
		1},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=true,
	texture="White.png",
	shader="VertexColorUnlitTinted"
}